"""Ncl colormaps for emission plots.

Comes from https://github.com/samwisehawkins/nclcmaps
Most of the colormaps from the original file were removed 
as not needed.

Can be used as follows::

    from emiproc.plots import nclcmaps

    cmap = nclcmaps.cmap("WhViBlGrYeOrRe")

    plt.imshow(*args, cmap=cmap)


"""
import numpy as np
import matplotlib as mpl
from matplotlib.colors import ListedColormap
import matplotlib.pyplot as plt

__all__ = ["nclcmaps"]

colors = {
    "WhViBlGrYeOrRe": [
        [255.0, 255.0, 255.0],
        [245.0, 240.0, 248.0],
        [235.0, 225.0, 241.0],
        [225.0, 210.0, 234.0],
        [215.0, 195.0, 227.0],
        [206.0, 180.0, 220.0],
        [196.0, 165.0, 213.0],
        [186.0, 150.0, 206.0],
        [176.0, 135.0, 199.0],
        [166.0, 120.0, 192.0],
        [156.0, 105.0, 185.0],
        [146.0, 90.0, 178.0],
        [136.0, 75.0, 171.0],
        [127.0, 60.0, 164.0],
        [117.0, 45.0, 157.0],
        [107.0, 30.0, 150.0],
        [97.0, 15.0, 143.0],
        [87.0, 0.0, 136.0],
        [82.0, 0.0, 143.0],
        [76.0, 0.0, 151.0],
        [71.0, 0.0, 158.0],
        [65.0, 0.0, 166.0],
        [60.0, 0.0, 173.0],
        [54.0, 0.0, 181.0],
        [49.0, 0.0, 188.0],
        [44.0, 0.0, 196.0],
        [38.0, 0.0, 203.0],
        [33.0, 0.0, 210.0],
        [27.0, 0.0, 218.0],
        [22.0, 0.0, 225.0],
        [16.0, 0.0, 233.0],
        [11.0, 0.0, 240.0],
        [5.0, 0.0, 248.0],
        [0.0, 0.0, 255.0],
        [0.0, 11.0, 241.0],
        [1.0, 21.0, 227.0],
        [1.0, 32.0, 213.0],
        [2.0, 42.0, 199.0],
        [2.0, 53.0, 184.0],
        [3.0, 63.0, 170.0],
        [3.0, 74.0, 156.0],
        [4.0, 84.0, 142.0],
        [4.0, 95.0, 128.0],
        [5.0, 105.0, 114.0],
        [5.0, 116.0, 100.0],
        [6.0, 126.0, 86.0],
        [6.0, 137.0, 71.0],
        [7.0, 147.0, 57.0],
        [7.0, 158.0, 43.0],
        [8.0, 168.0, 29.0],
        [8.0, 179.0, 15.0],
        [23.0, 183.0, 14.0],
        [37.0, 188.0, 13.0],
        [52.0, 192.0, 12.0],
        [66.0, 197.0, 11.0],
        [81.0, 201.0, 11.0],
        [95.0, 206.0, 10.0],
        [110.0, 210.0, 9.0],
        [124.0, 215.0, 8.0],
        [139.0, 219.0, 7.0],
        [153.0, 224.0, 6.0],
        [168.0, 228.0, 5.0],
        [182.0, 233.0, 4.0],
        [197.0, 237.0, 4.0],
        [211.0, 242.0, 3.0],
        [226.0, 246.0, 2.0],
        [240.0, 251.0, 1.0],
        [255.0, 255.0, 0.0],
        [255.0, 249.0, 0.0],
        [255.0, 244.0, 0.0],
        [255.0, 238.0, 0.0],
        [255.0, 233.0, 0.0],
        [255.0, 227.0, 0.0],
        [255.0, 221.0, 0.0],
        [255.0, 216.0, 0.0],
        [255.0, 210.0, 0.0],
        [255.0, 204.0, 0.0],
        [255.0, 199.0, 0.0],
        [255.0, 193.0, 0.0],
        [255.0, 188.0, 0.0],
        [255.0, 182.0, 0.0],
        [255.0, 176.0, 0.0],
        [255.0, 171.0, 0.0],
        [255.0, 165.0, 0.0],
        [255.0, 155.0, 0.0],
        [255.0, 146.0, 0.0],
        [255.0, 136.0, 0.0],
        [255.0, 126.0, 0.0],
        [255.0, 116.0, 0.0],
        [255.0, 107.0, 0.0],
        [255.0, 97.0, 0.0],
        [255.0, 87.0, 0.0],
        [255.0, 78.0, 0.0],
        [255.0, 68.0, 0.0],
        [255.0, 58.0, 0.0],
        [255.0, 49.0, 0.0],
        [255.0, 39.0, 0.0],
        [255.0, 29.0, 0.0],
        [255.0, 19.0, 0.0],
        [255.0, 10.0, 0.0],
        [255.0, 0.0, 0.0],
    ],
}


def cmap(name):
    data = np.array(colors[name])
    data = data / np.max(data)
    cmap = ListedColormap(data, name=name)
    return cmap

mpl.colormaps.register(cmap=cmap("WhViBlGrYeOrRe"))